"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactClickOutside = _interopRequireDefault(require("@langleyfoxall/react-click-outside"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var Component =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Component, _React$Component);

  function Component(props) {
    var _this;

    _classCallCheck(this, Component);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Component).call(this, props));
    _this.state = {
      isOpen: false,
      style: null
    };
    _this.style = _this.style.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.toggleDropdown = _this.toggleDropdown.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.onClickOutside = _this.onClickOutside.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    return _this;
  }

  _createClass(Component, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.style, false);
      this.style();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.style, false);
    }
  }, {
    key: "className",
    value: function className() {
      var _this$props = this.props,
          className = _this$props.className,
          menuItems = _this$props.menuItems;
      return (0, _classnames.default)(['rd-dropdown', className, {
        'empty-dropdown': !menuItems.length
      }]);
    }
  }, {
    key: "style",
    value: function style() {
      var gutter = this.props.gutter;
      var trigger = this.refs.trigger;

      var _trigger$getBoundingC = trigger.getBoundingClientRect(),
          width = _trigger$getBoundingC.width,
          height = _trigger$getBoundingC.height,
          top = _trigger$getBoundingC.top,
          left = _trigger$getBoundingC.left;

      var x = width / 2 + left;
      var y = height + top + gutter;
      this.setState({
        style: {
          top: y,
          left: x,
          position: 'absolute',
          transform: 'translateX(-50%)'
        }
      });
    }
  }, {
    key: "toggleDropdown",
    value: function toggleDropdown() {
      var isOpen = this.state.isOpen;
      this.setState({
        isOpen: !isOpen
      });
    }
  }, {
    key: "onClickOutside",
    value: function onClickOutside(_ref) {
      var target = _ref.target;
      var trigger = this.refs.trigger;

      if (target === trigger || trigger.contains(target)) {
        return;
      }

      this.setState({
        isOpen: false
      });
    }
  }, {
    key: "renderDropdown",
    value: function renderDropdown() {
      var _this$state = this.state,
          isOpen = _this$state.isOpen,
          style = _this$state.style;
      var _this$props2 = this.props,
          menuItems = _this$props2.menuItems,
          emptyMessage = _this$props2.emptyMessage;

      if (isOpen) {
        return _react.default.createElement(_reactClickOutside.default, {
          onClickOutside: this.onClickOutside
        }, _react.default.createElement("ul", {
          ref: 'dropdown',
          className: this.className(),
          style: style
        }, menuItems.map(function (_ref2) {
          var content = _ref2.content,
              onClick = _ref2.onClick;
          return _react.default.createElement("li", {
            key: content,
            onClick: onClick
          }, content);
        }), !menuItems.length && _react.default.createElement("li", null, emptyMessage)));
      }

      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          child = _this$props3.children,
          content = _this$props3.content;
      return _react.default.createElement(_react.default.Fragment, null, _react.default.cloneElement(content || child, {
        ref: 'trigger',
        onClick: this.toggleDropdown
      }), _reactDom.default.createPortal(this.renderDropdown(), document.body));
    }
  }]);

  return Component;
}(_react.default.Component);

Component.defaultProps = {
  menuItems: [],
  emptyMessage: 'No Options Found',
  gutter: 5
};
Component.propTypes = {
  children: _propTypes.default.node,
  content: _propTypes.default.node,
  menuItems: _propTypes.default.arrayOf(_propTypes.default.shape({
    content: _propTypes.default.node,
    onClick: _propTypes.default.func
  })),
  emptyMessage: _propTypes.default.node,
  guttter: _propTypes.default.number,
  className: _propTypes.default.string,
  style: _propTypes.default.object
};
var _default = Component;
exports.default = _default;